    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------
    028     * PlumNeedle.java
    029     * ---------------
    030     * (C) Copyright 2002-2005, by the Australian Antarctic Division and
    031     *                          Contributors.
    032     *
    033     * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * $Id: PlumNeedle.java,v 1.4.2.2 2005/10/25 20:50:49 mungady Exp $
    037     *
    038     * Changes:
    039     * --------
    040     * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    041     * 27-Mar-2003 : Implemented Serializable (DG);
    042     * 09-Sep-2003 : Added equals() method (DG);
    043     * 08-Jun-2005 : Implemented Cloneable (DG);
    044     *
    045     */
    046
    047    package org.jfree.chart.needle;
    048
    049    import java.awt.Graphics2D;
    050    import java.awt.geom.Arc2D;
    051    import java.awt.geom.Area;
    052    import java.awt.geom.Point2D;
    053    import java.awt.geom.Rectangle2D;
    054    import java.io.Serializable;
    055
    056    /**
    057     * A needle for use with the {@link org.jfree.chart.plot.CompassPlot} class.
    058     *
    059     * @author Bryan Scott
    060     */
    061    public class PlumNeedle extends MeterNeedle
    062                            implements Cloneable, Serializable {
    063
    064        /** For serialization. */
    065        private static final long serialVersionUID = -3082660488660600718L;
    066
    067        /**
    068         * Draws the needle.
    069         *
    070         * @param g2  the graphics device.
    071         * @param plotArea  the plot area.
    072         * @param rotate  the rotation point.
    073         * @param angle  the angle.
    074         */
    075        protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    076                                  Point2D rotate, double angle) {
    077
    078            Arc2D shape = new Arc2D.Double(Arc2D.PIE);
    079            double radius = plotArea.getHeight();
    080            double halfX = plotArea.getWidth() / 2;
    081            double diameter = 2 * radius;
    082
    083            shape.setFrame(plotArea.getMinX() + halfX - radius ,
    084                           plotArea.getMinY() - radius,
    085                           diameter, diameter);
    086            radius = Math.toDegrees(Math.asin(halfX / radius));
    087            shape.setAngleStart(270 - radius);
    088            shape.setAngleExtent(2 * radius);
    089
    090            Area s = new Area(shape);
    091
    092            if ((rotate != null) && (angle != 0)) {
    093                /// we have rotation houston, please spin me
    094                getTransform().setToRotation(angle, rotate.getX(), rotate.getY());
    095                s.transform(getTransform());
    096            }
    097
    098            defaultDisplay(g2, s);
    099        }
    100
    101        /**
    102         * Tests another object for equality with this object.
    103         *
    104         * @param obj  the object to test (<code>null</code> permitted).
    105         *
    106         * @return A boolean.
    107         */
    108        public boolean equals(Object obj) {
    109            if (obj == this) {
    110                return true;
    111            }
    112            if (!(obj instanceof PlumNeedle)) {
    113                return false;
    114            }
    115            if (!super.equals(obj)) {
    116                return false;
    117            }
    118            return true;
    119        }
    120
    121        /**
    122         * Returns a clone of this needle.
    123         *
    124         * @return A clone.
    125         */
    126        public Object clone() throws CloneNotSupportedException {
    127            return super.clone();
    128        }
    129
    130    }